import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["icon", "iconRight", "label", "size", "type", "design", "isFitted"];
import PropTypes from 'prop-types';
import cx from 'classnames';
import { SIZES, TYPES, DESIGNS, CLASS_ICON, CLASS_ICON_RIGHT, CLASS_TEXT, truncateText, getClassNames, shouldRenderIcon } from './config';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var AtomBadge = function AtomBadge(_ref) {
  var icon = _ref.icon,
      iconRight = _ref.iconRight,
      label = _ref.label,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? SIZES.SMALL : _ref$size,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? TYPES.SUCCESS : _ref$type,
      _ref$design = _ref.design,
      design = _ref$design === void 0 ? DESIGNS.SOLID : _ref$design,
      _ref$isFitted = _ref.isFitted,
      isFitted = _ref$isFitted === void 0 ? false : _ref$isFitted,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var truncatedLabel = truncateText(label);
  var classNames = getClassNames(_extends({
    icon: icon,
    iconRight: iconRight,
    label: label,
    size: size,
    type: type,
    design: design,
    isFitted: isFitted
  }, props));
  return /*#__PURE__*/_jsxs("div", {
    className: classNames,
    children: [shouldRenderIcon(_extends({
      icon: icon
    }, props)) && !iconRight && /*#__PURE__*/_jsx("span", {
      className: CLASS_ICON,
      children: icon
    }), /*#__PURE__*/_jsx("span", {
      className: CLASS_TEXT,
      title: truncatedLabel,
      children: label
    }), shouldRenderIcon(_extends({
      icon: icon
    }, props)) && iconRight && /*#__PURE__*/_jsx("span", {
      className: cx(CLASS_ICON, CLASS_ICON_RIGHT),
      children: icon
    })]
  });
};

AtomBadge.displayName = 'AtomBadge';
export default AtomBadge;